package biblioteca;

import java.io.*;
import java.util.*;

public class Libreria3
{
	//ArrayList<Autore> autori;
	Map<SearchKey, Autore> autori;

	public Libreria3()
	{
		//autori = new ArrayList<Autore>();
		//autori = new HashMap<SearchKey, Autore>();

		//voglio che DENTRO la mappa sia gia' tutto ordinato per SearchKey
		autori = new TreeMap<SearchKey, Autore>(new ComparaSearchKey());
	}

	public void mainLoop()
	{
		Scanner scIn;

		scIn = new Scanner(System.in);

		while(true)
		{
			System.out.print("Comando ? > ");
			String line = scIn.nextLine();

			if(line.equals("") || line.equals("esci") || line.equals("basta"))
			{
				//esco
				break;
			}
			else if(line.equals("leggi"))
			{
				leggi(scIn);
			}
			else if(line.equals("autore"))
			{
				autore(scIn);
			}
			else if(line.equals("stampa"))
			{
				stampa(scIn);
			}
			else
			{
				System.out.println("Comando <" + line + "> non riconosciuto");
			}
		}
		scIn.close();
	}
	
	private void leggi(Scanner scIn)
	{
		//leggo da file
		Scanner scFile;

		System.out.print("Nome file ? > ");
		String nomeFile = scIn.nextLine();

		try
		{
			scFile = new Scanner(new File(nomeFile));
			//assumo che il file contenga sempre gruppi di tre
			//linee, niente records smozzicati.
			while(scFile.hasNextLine())
			{
				String tipo = scFile.nextLine();
				if(!tipo.equals("biblioteca.Libro"))
				{
					System.out.println("Media di tipo <" + tipo + "> non gestito");
					continue;
				}
				Libro nuovoLibro = new Libro(scFile.nextLine(), scFile.nextLine(), Integer.parseInt(scFile.nextLine()), scFile.nextLine());
				Autore autNuovo = null;
				autNuovo = autori.get(new SearchKey(nuovoLibro.autore));
				if(autNuovo == null)//non ho ancora un riferimento a questo autore?
				{
					autNuovo = new Autore(nuovoLibro.autore);
					autori.put(new SearchKey(nuovoLibro.autore), autNuovo);
				}
				autNuovo.add(nuovoLibro);
			}
			scFile.close();
			System.out.println(autori);
		}
		catch(FileNotFoundException fnfe)
		{
			fnfe.printStackTrace();
		}
	}

	private void autore(Scanner scIn)
	{
		//stampo il singolo autore
		System.out.print("Autore ? > ");
		String autore = scIn.nextLine();

		Autore aut = autori.get(new SearchKey(autore));
		if(aut == null)
		{
			System.out.println("Non ho riferimento all'autore " + autore);
			return;
		}
		System.out.println(aut);
	}

	private void stampa(Scanner scIn)
	{
		//stampo tutto
		//voglio la stampa in ordine per autore, ma stampare semplicemente
		//la HashMap non funziona.
		//System.out.println(autori);

		//Cosi' funziona con qualsiasi Map
		// ma e' un pizza
		/*
		Set<SearchKey> set = autori.keySet();
		List<SearchKey> listaAutori = new LinkedList<SearchKey>();
		listaAutori.addAll(set);
		Collections.sort(listaAutori, new ComparaSearchKey());
		ListIterator<SearchKey> iter = listaAutori.listIterator();
		while(iter.hasNext())
		{
			SearchKey current = iter.next();
			System.out.println("- " + autori.get(current) + "\n");
		}
		*/

		//io voglio proprio poterlo fare in un colpo solo
		System.out.println(autori);
	}

	public static void main(String[] argv)
	{
		(new Libreria3()).mainLoop();
	}
}
